local RestEnabled;
local InstanceEnabled;
local InstanceQuestEnabled;

-----Loads settings from savedvariables if there is any, and they are valid, and saves them on logout
local s = CreateFrame("frame");
s:RegisterEvent("PLAYER_LOGIN");
s:RegisterEvent("PLAYER_LOGOUT");
function s:OnEvent(event)
	if(event == "PLAYER_LOGIN") then
			if(HQO_Settings["RestEnabled"] == true or HQO_Settings["RestEnabled"] == false) then 
				RestEnabled = HQO_Settings["RestEnabled"]; 
			else
				RestEnabled = true;
			end
			if(HQO_Settings["InstanceEnabled"] == true or HQO_Settings["InstanceEnabled"] == false) then 
				InstanceEnabled = HQO_Settings["InstanceEnabled"];
			else
				InstanceEnabled = true;
			end
			if(HQO_Settings["InstanceQuestEnabled"] == true or HQO_Settings["InstanceQuestEnabled"] == false) then 
				InstanceQuestEnabled = HQO_Settings["InstanceQuestEnabled"];
			else
				InstanceQuestEnabled = false;
			end
	elseif(event == "PLAYER_LOGOUT") then
		HQO_Settings = {
		["RestEnabled"] = RestEnabled;
		["InstanceEnabled"] = InstanceEnabled;
		["InstanceQuestEnabled"] = InstanceQuestEnabled;
		}
	end
end

s:SetScript("OnEvent", s.OnEvent);



--Collapses or expands the objective tracker
function ObjectiveTracker()
	if(RestEnabled == true) then --Checks if resting is enabled and if currently in rested zone
		if(IsResting() == true) then
			ObjectiveTracker_Collapse();
			return;
		end
	end
	if(InstanceEnabled == true and IsInInstance() == true) then --Checks if Instance is enabled and if currently in an instance
		local MapAreaId = GetCurrentMapAreaID();
		local ZoneQuests = GetQuestsForPlayerByMapID(MapAreaId);
		if(InstanceQuestEnabled == true and #ZoneQuests > 0) then --Checks  if InstanceQuest is enabled and if there any instance quests in current instance
			ObjectiveTracker_Expand();
		else
			ObjectiveTracker_Collapse();
		end
	else
		ObjectiveTracker_Expand();
	end
end



--Eventhandlers for ObjectiveTracker()
local f = CreateFrame("Frame");
f:RegisterEvent("PLAYER_UPDATE_RESTING");
f:RegisterEvent("PLAYER_ENTERING_WORLD");
f:RegisterEvent("QUEST_REMOVED");
f:RegisterEvent("QUEST_POI_UPDATE");--The only quest event that seemed to fire after quest had been accepted
f:SetScript("OnEvent",ObjectiveTracker);



--Handler for slash commands
SLASH_HQO1, SLASH_HQO2 = '/hqo', '/hidequestobjectives';
function SlashCmdList.HQO(msgRaw, editBox)
	local msg = string.lower (msgRaw)--Converts to lower case
	if(msg == "resting enable" or msg == "rested enable") then
		RestEnabled = true;
		print("|cffffa500Objectives|r will |cffff0000be hidden|r in rested zones");
		ObjectiveTracker();
	elseif(msg == "resting disable" or msg == "rested disable") then
		RestEnabled = false;
		print("|cffffa500Objectives|r will |cffffff00not be hidden|r in rested zones");
		ObjectiveTracker();
	elseif(msg == "instance enable") then
		InstanceEnabled = true;
		print("|cffffa500Objectives|r will |cffff0000be hidden|r in instances");
		ObjectiveTracker();
	elseif(msg == "instance disable") then
		InstanceEnabled = false;
		print("|cffffa500Objectives|r will |cffffff00not be hidden|r in instances");
		ObjectiveTracker();
	elseif(msg == "instancequest enable") then
		InstanceQuestEnabled = true;
		print("|cffffa500Objectives|r will |cffffff00not be hidden|r when you have quests in your current dungeon");
		ObjectiveTracker();
	elseif(msg == "instancequest disable") then
		InstanceQuestEnabled = false;
		print("|cffffa500Objectives|r will |cffff0000be hidden|r when you have quests in your current dungeon");
		ObjectiveTracker();
	elseif(msg == "showsettings" or msg == "show settings") then
		local RestSetting if RestEnabled == true then RestSetting = "|cffffff00enabled|r" elseif RestEnabled == false then RestSetting = "|cffff0000disabled|r" else RestSetting = "bugged" end
		local InstanceSetting if InstanceEnabled == true then InstanceSetting = "|cffffff00enabled|r" elseif InstanceEnabled == false then InstanceSetting = "|cffff0000disabled|r" else InstanceSetting = "bugged" end
		local InstanceQuestSetting if InstanceQuestEnabled == true then InstanceQuestSetting = "|cffffff00enabled|r" elseif InstanceQuestEnabled == false then InstanceQuestSetting = "|cffff0000disabled|r" else InstanceQuestSetting = "bugged" end
		print("\n\n|cffffa500HideQuestObjectives|r is",RestSetting,"in rested zones.\n|cffffa500HideQuestObjectives|r is",InstanceSetting,"in instances.\n|cffffa500HideQuestObjectives|r is",InstanceQuestSetting,"when you have quests in your current instance\n");
	elseif(msg == "help") then
		print("\n\n Type |cffffa500/hqo rested|r |cffffff00enable/disable|r to enable or disable the addon in rested zones \n Type |cffffa500/hqo instance|r |cffffff00enable/disable|r to enable or disable the addon in instances \n Type |cffffa500/hqo instancequest|r |cffffff00enable/disable|r to enable or disable the addon when you have quests for your current instance\nType |cffffa500/hqo|r |cffffff00showsettings|r to show your current settings\n");	
	else
		print("\nType |cffffa500/hqo|r |cffffff00help|r to list commands for HideQuestObjectives");
	end
end